"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
const utils = __importStar(require("../utils"));
const lc = __importStar(require("../leetcode"));
const gqlQueries = __importStar(require("../gqlqueries"));
const CreateCommand = async (data, state) => {
    // Obtain the problem title from the current state if exists
    if (state.lastSelectedProblems === undefined) {
        console.error("No locally fetched problems. Consider running `fetch` or `list` command" +
            "before `create`.");
        return state;
    }
    var problem_idxs;
    const fetch_length = state.lastSelectedProblems.problemsetQuestionList.length;
    if (data[0] !== undefined) {
        const problem_idx = Number.parseInt(data[0]);
        if (problem_idx >= fetch_length) {
            console.error("Given index exceeds number of locally fetched problems. Consider\n" +
                "increasing the `LIMIT` variable and run the `list` command again\n" +
                "or directly locally fetching the specified problem either providing\n" +
                "the frontend Id or the title-slug.");
            return state;
        }
        problem_idxs = [problem_idx];
    }
    else {
        problem_idxs = Array.from({ length: fetch_length }, (_, n) => n);
    }
    var last_question = null;
    for (let idx = 0; idx < problem_idxs.length; idx++) {
        const question = await lc.FetchQuestion(state.lastSelectedProblems.problemsetQuestionList[problem_idxs[idx]].titleSlug, utils.FormatQuestionData, gqlQueries.singleProblemQuery);
        last_question = question;
        if (!question)
            continue; // If there is no question, continue
        utils.CreateQuestionInstance(last_question, state.variables[4].value);
    }
    state.lastQuestion = (last_question) ? last_question : undefined;
    return state;
};
// Create Command - "Download" a problem instance locally
const create_command = {
    name: 'Create Command',
    command: 'create',
    syntax: /^create(?:\s+(\d+))?$/,
    callback: CreateCommand,
    help: 'create <IDX> - Downloads a problem instance locally given the local index.\n' +
        'If the local index exists, it creates a new folder into the `FOLER` folder\n' +
        'named `<id>-<titleSlug>`. This folder will contain: a README.md file and a\n' +
        'index.html file with the problem description, and the source code file. Errors\n' +
        'when the input index is out of bound or if the list is empty. If no index is\n' +
        'specified, then it will downloads all the fetched problems.\n'
};
exports.default = create_command;
