"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
const utils = __importStar(require("../utils"));
const lc = __importStar(require("../leetcode"));
const gqlQueries = __importStar(require("../gqlqueries"));
const FetchCommand = async (data, state) => {
    const is_by_id = data[2] !== undefined;
    // Two possible ways to fetch the question. The first way is by ID.
    let problems_data = null;
    if (is_by_id) {
        const category = state.variables[0].value;
        problems_data = await lc.FetchProblems({ category: category, limit: 1, skip: Number.parseInt(data[2]) - 1 }, utils.FormatProblemsData, gqlQueries.problemListQuery);
        if (!problems_data) {
            console.error(`No problem with ID ${data[2]}`);
            return state;
        }
    }
    else {
        const category = state.variables[0].value;
        problems_data = await lc.FetchProblems({ category: category }, utils.FormatProblemsData, gqlQueries.problemListQuery);
        if (!problems_data)
            return state;
        const selected_problem = problems_data.problemsetQuestionList.filter((value) => (value.titleSlug === data[1]));
        if (selected_problem.length < 1) {
            console.error(`No problem with title ${data[1]}`);
            return state;
        }
        problems_data.count = 1;
        problems_data.problemsetQuestionList = selected_problem;
    }
    utils.PrintProblemsSummary(problems_data);
    // Add the problems to the state
    if (state.lastSelectedProblems === undefined) {
        state.lastSelectedProblems = problems_data;
    }
    else {
        state.lastSelectedProblems.problemsetQuestionList.push(problems_data.problemsetQuestionList[0]);
        state.lastSelectedProblems.count++;
    }
    return state;
};
// Fetch Command - "Download" a single question
const fetch_command = {
    name: 'Fetch Command',
    command: 'fetch',
    syntax: /^fetch\s+(NAME\s+([\w\-]+)|ID\s+(\d+)){1,}$/,
    callback: FetchCommand,
    help: 'fetch <NAME|ID> <value> - Fetch locally a single problem from remote. Notice\n' +
        'that: NAME is the title-slug which means the real title lower-case and spaces\n' +
        'replaced by `-`; ID is the frontend Id, i.e., the number identifying the problem.\n'
};
exports.default = fetch_command;
