"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
const utils = __importStar(require("../utils"));
const utils_1 = require("./utils");
const ShowCommand = async (data, state) => {
    // Shows some variables and informations about the state
    console.log("STATE INFORMATIONS\n------------------");
    console.log("Last Command:", state.lastCommand || "EMPTY");
    console.log("Selected User:", state.selectedUser || "EMPTY");
    console.log("");
    if (state.lastSelectedProblems !== undefined) {
        utils.PrintProblemsSummary(state.lastSelectedProblems);
    }
    else {
        console.log("Total Problems: EMPTY");
    }
    console.log("");
    if (state.lastQuestion !== undefined) {
        utils.PrintQuestionSummary(state.lastQuestion);
    }
    else {
        console.log("Last Question: EMPTY");
    }
    console.log("\nVARIABLES\n---------");
    state.variables.forEach((value, idx) => {
        console.log(utils.FormatString("{0} => {1} {2}", value.name, value.value.toString(), utils_1.working_values[idx]));
    });
    console.log("");
    return state;
};
// Show Command - shows some informations of the app state
const show_command = {
    name: 'Show Command',
    command: 'show',
    syntax: /^show$/,
    callback: ShowCommand,
    help: 'show - Shows values and informations about the state.\n'
};
exports.default = show_command;
