"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConstructRegex = exports.working_values = exports.app_variables = void 0;
const utils = __importStar(require("../utils"));
exports.app_variables = [
    { name: 'CATEGORY', match: 'CATEGORY\\s(\\w+)', value: "algorithms", default: "algorithms", type: "s" },
    { name: 'LIMIT', match: 'LIMIT\\s(\\d+)', value: 20, default: 20, type: "n" },
    { name: 'SKIP', match: 'SKIP\\s(\\d+)', value: 0, default: 0, type: "n" },
    { name: 'DIFFICULTY', match: 'DIFFICULTY\\s(\\w+)', value: "EASY", default: "ALL", type: "s" },
    { name: 'FOLDER', match: 'FOLDER\\s([\\w\\./-]+)', value: './problems', default: "./problems", type: "s" },
];
exports.working_values = [
    "(Possible values: algorithms)",
    "(Possible values: 1...Inf)",
    "(Possible values: 1...Inf)",
    "(Possible values: Easy, Medium, Hard, All)",
    "(Possible values: any folder name)"
];
const ConstructRegex = (name, vars, unset) => {
    const prefix = utils.FormatString("^{0}", name);
    const regex_str = vars.map((value) => {
        const name_val = "(" + value.name + ")";
        return utils.FormatString("(?:\\s+{0})?", (unset || false) ? name_val : value.match);
    }).reduce((prev, curr) => (prev + curr));
    return new RegExp(prefix + regex_str);
};
exports.ConstructRegex = ConstructRegex;
