"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FetchQuestion = exports.FetchProblems = void 0;
const FetchProblems = async (options, formatData, query) => {
    try {
        // Adjust the query variables to correct values
        const category = options.category === undefined ? '' : options.category;
        const tags = options.tags ? options.tags.split(' ') : [];
        const skip = options.skip || 0;
        const difficulty = options.difficulty || undefined;
        const limit = options.limit || 20;
        // Sends a post requests to the graphql endpoint of leetcode
        const response = await fetch('https://leetcode.com/graphql', {
            method: 'POST',
            headers: {
                'Content-Type': 'application/json',
                Referer: 'https://leetcode.com',
            },
            body: JSON.stringify({
                query: query,
                variables: {
                    categorySlug: category,
                    skip: skip,
                    limit: limit,
                    filters: { tags, difficulty },
                }
            }),
        });
        // Obtain the json response representation
        const result = await response.json();
        return formatData(result.data);
    }
    catch (error) {
        console.error("Error when fetching problems: ", error);
        return null;
    }
};
exports.FetchProblems = FetchProblems;
const FetchQuestion = async (titleSlug, formatData, query) => {
    try {
        // Sends a post requests to the graphql endpoint of leetcode
        const response = await fetch('https://leetcode.com/graphql', {
            method: 'POST',
            headers: {
                'Content-Type': 'application/json',
                Referer: 'https://leetcode.com',
            },
            body: JSON.stringify({
                query: query,
                variables: {
                    titleSlug: titleSlug,
                }
            }),
        });
        // Obtain the json response representation
        const result = await response.json();
        return formatData(result.data);
    }
    catch (error) {
        console.error("Error when fetching question: ", error);
        return null;
    }
};
exports.FetchQuestion = FetchQuestion;
